HashSlotMap (rhino 1.7.15 API)

Package org.mozilla.javascript

## Class HashSlotMap

- java.lang.Object
- - org.mozilla.javascript.HashSlotMap

- All Implemented Interfaces:
    `java.lang.Iterable<Slot>`, `SlotMap`

      public class HashSlotMap
      extends java.lang.Object
      implements SlotMap

  This class implements the SlotMap interface using a java.util.HashMap. This class has more overhead than EmbeddedSlotMap, especially because it puts each "Slot" inside an intermediate object. However it is much more resistant to large number of hash collisions than EmbeddedSlotMap and therefore we use this implementation when an object gains a large number of properties.

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `HashSlotMap()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `add​(Slot newSlot)` | Insert a new slot to the map.
    `boolean` | `isEmpty()` | Return whether the map is empty.
    `java.util.Iterator<Slot>` | `iterator()` |
    `Slot` | `modify​(java.lang.Object key, int index, int attributes)` | Return the Slot that matches EITHER "key" or "index".
    `Slot` | `query​(java.lang.Object key, int index)` | Retrieve the slot at EITHER key or index, or return null if the slot cannot be found.
    `void` | `remove​(java.lang.Object key, int index)` | Remove the slot at either "key" or "index".
    `void` | `replace​(Slot oldSlot, Slot newSlot)` | Replace "slot" with a new slot.
    `int` | `size()` | Return the size of the map.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface java.lang.Iterable

      `forEach, spliterator`

- - ### Constructor Detail

    - #### HashSlotMap

          public HashSlotMap()

  - ### Method Detail

    - #### size

          public int size()

      Description copied from interface: `SlotMap`
      Return the size of the map.
      Specified by:
        `size` in interface `SlotMap`

    - #### isEmpty

          public boolean isEmpty()

      Description copied from interface: `SlotMap`
      Return whether the map is empty.
      Specified by:
        `isEmpty` in interface `SlotMap`

    - #### query

          public Slot query​(java.lang.Object key,
                            int index)

      Description copied from interface: `SlotMap`
      Retrieve the slot at EITHER key or index, or return null if the slot cannot be found.
      Specified by:
        `query` in interface `SlotMap`
      Parameters:
        `key` - The key for the slot, which should be a String or a Symbol.
        `index` - if key is zero, then this will be used as the key instead.
      Returns:
        either the Slot that matched the key and index, or null

    - #### modify

          public Slot modify​(java.lang.Object key,
                             int index,
                             int attributes)

      Description copied from interface: `SlotMap`
      Return the Slot that matches EITHER "key" or "index". (It will use "key" if it is not null, and otherwise "index".) If no slot exists, then create a default slot class.
      Specified by:
        `modify` in interface `SlotMap`
      Parameters:
        `key` - The key for the slot, which should be a String or a Symbol.
        `index` - if key is zero, then this will be used as the key instead.
        `attributes` - the attributes to be set on the slot if a new slot is created. Existing slots will not be modified.
      Returns:
        a Slot, which will be created anew if no such slot exists.

    - #### replace

          public void replace​(Slot oldSlot,
                              Slot newSlot)

      Description copied from interface: `SlotMap`
      Replace "slot" with a new slot. This is used to change slot types.
      Specified by:
        `replace` in interface `SlotMap`

    - #### add

          public void add​(Slot newSlot)

      Description copied from interface: `SlotMap`
      Insert a new slot to the map. Both "name" and "indexOrHash" must be populated. Note that ScriptableObject generally adds slots via the "modify" method.
      Specified by:
        `add` in interface `SlotMap`

    - #### remove

          public void remove​(java.lang.Object key,
                             int index)

      Description copied from interface: `SlotMap`
      Remove the slot at either "key" or "index".
      Specified by:
        `remove` in interface `SlotMap`
      Parameters:
        `key` - The key for the slot, which should be a String or a Symbol.
        `index` - if key is zero, then this will be used as the key instead.

    - #### iterator

          public java.util.Iterator<Slot> iterator()

      Specified by:
        `iterator` in interface `java.lang.Iterable<Slot>`